/*
Research Project:   Graphical Database for Category Theory
                    J. Bradbury, Dr. R. Rosebrugh, I. Rutherford
                    Mount Allison University 2001
File:               AboutAuthors.java
Description:	      This file is displayed when the user selects the "About Authors"
                    menu option in the main window. It displays basic information
                    about authors of the project
*/

//import statements
import java.applet.Applet;
import java.awt.*;

class AboutAuthors extends Frame
{

 int check_enter = 0;
 Button exit = new Button();
 Panel button_panel = new Panel();
 BorderLayout borderLayout1 = new BorderLayout();

 public AboutAuthors()
 {
  //call base class constructor
  //super(s);
  //logo = lo;
  setTitle("About GDCT Authors");
  exit.setLabel("OK");
  this.setLayout(borderLayout1);
  button_panel.add(exit);
  this.add("South",button_panel);
  this.setBackground(new Color(192,192,192));
  this.setSize(600, 600);
 }

  public boolean handleEvent(Event e)
  {
   if (e.id == Event.WINDOW_DESTROY || e.key == Event.ENTER)
   {
     setVisible(false);            //hide frame
     dispose();         //free resources
     return true;
   }
   return super.handleEvent(e);
 }

 public void paint(Graphics g)
 {
  //g.setColor(Color.white);

  //g.drawImage(logo, 10, 25, this);
  g.drawImage(getToolkit().getImage("images/authors.jpg"), 4, 23, this);
 }

 public boolean processEvent(Event e)
 {
  if ((e.id == Event.WINDOW_DESTROY) || (e.id == Event.ACTION_EVENT))
  {
     setVisible(false);            //hide frame
     dispose();         //free resources
     return true;
  }
  if (e.key == Event.ENTER)
  {
    if (check_enter == 0)
       check_enter++;
    else
    {
       setVisible(false);            //hide frame
       dispose();         //free resources
    }
    return true;
  }
  return super.handleEvent(e);
 }

 public boolean action(Event e, Object o)
 {
  if ((e.target == exit) || (e.key == Event.ENTER))
  {
   setVisible(false);            //hide frame
   dispose();         //free resources
   return true;
  }

  return false;
 }
}