/*
Research Project:   Graphical Database for Category Theory
                    J. Bradbury, Dr. R. Rosebrugh, I. Rutherford
                    Mount Allison University 2001
File:               BiconnectData.java
                    (author: Gerald Carter, Auburn University, 10/21/96)
Description:	      Data object for storing node information used in implementing
                    J.E. Hopcroft's depth-first traversal of a graph to determine
                    the Articulation Points of the graph. Basically, this is a
                    data object for generic information field in Graph class. It
                    is used by the class BiconnectGraph.
*/

public class BiconnectData {
   private int		num;    // the number of the node as determined
// **				// by the DFS
   private int		low;     	// lowest numbered node reachable by n
// **				// edges and at most on back edge
   private boolean	articulationPt;   // is the node an articulation point?
   private boolean 	visited; // has the node been previously visited?
   private int		childCount;
   private int		node_index;

   // Default constructor
   public BiconnectData () {
      num = -1;
      low = -1;
      articulationPt = false;
      visited = false;
      childCount = 0;
      node_index = -1;
   }

   // Set and Get methods
   public boolean SetNumber ( int x ) { num = x; return ( true ); }
   public int GetNumber () { return ( num ); }
   public boolean SetLow ( int x ) { low = x; return ( true ); }
   public int GetLow () { return ( low ); }
   public boolean SetArticulationPoint ( boolean x ) 
      { articulationPt = x; return ( true ); }
   public boolean IsArticulationPoint () { return ( articulationPt ); }
   public boolean SetVisited ( boolean x ) { visited = x; return ( true ); }
   public boolean Visited () { return ( visited ); }
   public int GetChildCount () { return ( childCount ); }
   public int SetChildCount ( int x ) { childCount = x; return ( childCount ); }
   public int SetIndex ( int x ) { return ( node_index = x ); }
   public int GetIndex ( ) { return ( node_index ); }
}

// ******* end of BiconnectData.java **********************************
// ********************************************************************
