/*
Research Project:   Graphical Database for Category Theory
                    J. Bradbury, Dr. R. Rosebrugh, I. Rutherford
                    Mount Allison University 2001
File:               FunctorNode.java
Description:	      This class contains the information about a functor that is
                    later stored in a linked list.
*/

class FunctorNode
//class FunctorNode definition
{
  CatFunctor f;
  FunctorNode next;
  Category A;
  Category B;
  Category diagram;
  int functor_type;
  int saved;
  MainWindow ed;

  FunctorNode(MainWindow edit)
  //Default constructor for FunctorNode class
  {
    ed = edit;
    f = new CatFunctor();
    next = null;
    A = new Category();
    B = new Category();
    diagram = new Category();
    functor_type = 0;
  }

  FunctorNode(MainWindow edit, Category newA, Category newB, Category newDiagram, CatFunctor newf)
  //Alternate constructor that is applicable when category A and B
  //along with the cat_functor are included as parameters
  {
     ed = edit;
     A = newA;
     B = newB;
     diagram = newDiagram;
     f = newf;
     next = null;
  }
}
