/*
Research Project:   Graphical Database for Category Theory
                    J. Bradbury, Dr. R. Rosebrugh, I. Rutherford
                    Mount Allison University 2001
File:               RemoveFunctorFrame.java
Description:	      This file is displayed when the user selects the "Remove
                    Functor" menu option in the main window. It displays a
                    list of functors that are presently in memory. The user
                    can select a functor and chose to remove it.
*/

//import statements
import java.applet.Applet;
import java.net.*;
import java.io.*;
import java.util.*;
import java.lang.System;
import java.io.StringBufferInputStream;
import java.awt.*;
import java.awt.event.*;

public class RemoveFunctorFrame extends Frame {

  public String filename = new String();
  int check_enter = 0;
  Button exit = new Button();
  Panel button_panel = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  Button okButton = new Button();
  java.awt.List funcRemoveList = new java.awt.List();
  Button cancelButton = new Button();
  MainWindow edit;
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  GBConstraintsEditor g = new GBConstraintsEditor();

  public RemoveFunctorFrame(MainWindow ed)
  {
    edit = ed;
    try  {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

 public boolean handleEvent(Event e)
 {
  if ((e.id == Event.WINDOW_DESTROY) || (e.id == Event.ACTION_EVENT))
  {
     hide();            //hide frame
     dispose();         //free resources
     return true;
  }
  else if (e.key == Event.ENTER)
  {
    if (check_enter == 0)
       check_enter++;
    else
    {
       hide();            //hide frame
       dispose();         //free resources
    }
    return true;
  }
  return super.handleEvent(e);
 }

 public boolean action(Event e, Object o)
 {
  if ((e.target == exit) || (e.key == Event.ENTER))
  {
   hide();            //hide frame
   dispose();         //free resources
   return true;
  }
  return false;
 }

  private void jbInit() throws Exception {
    this.setTitle("GDCT: Remove Functor");
    this.setBackground(new Color(192,192,192));
    okButton.setLabel("OK");
    okButton.setLabel("OK");
    okButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        funcRemoveList_okButton_actionPerformed(e);
      }
    });
    cancelButton.setLabel("cancel");

    funcRemoveList.setBackground(Color.white);
    funcRemoveList.addActionListener(new java.awt.event.ActionListener() {
     public void actionPerformed(ActionEvent e) {
        funcRemoveList_okButton_actionPerformed(e);
      }
    });
    this.setLayout(gridBagLayout1);
    this.add(okButton, g.getConstraints(1, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(24, 13, 0, 17), 97, 8));
    this.add(funcRemoveList, g.getConstraints(0, 0, 1, 3, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(9, 13, 16, 0), 2, 47));
    this.add(cancelButton, g.getConstraints(1, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(12, 13, 0, 17), 78, 8));
    funcRemoveList.clear();
    FunctorNode current = edit.f_list.head;
    while(current != null)
    {
      funcRemoveList.addItem(current.f.name);
      current = current.next;
    }
  }

  void funcRemoveList_okButton_actionPerformed(ActionEvent e)
  {
      String name;
      boolean test;
      if (funcRemoveList.getSelectedItem() != null)
      {
        name = funcRemoveList.getSelectedItem();
        if (!name.equals(""))
        {
          test = edit.f_list.removeNode(name);
          boolean current = false;
          if (name.equals(edit.functorChoice.getSelectedItem()))
          {
            edit.functorObjectArea.setText("");
            edit.functorArrowArea.setText("");
            //boolean graph = edit.displayFunctor("graph [directed 1]");
            current = true;
          }
          edit.functorChoice.remove(name);
          /*if (current == true && edit.functorChoice.countItems() != 0)
          {
            edit.f = l.getNode(edit.functorChoice.getSelectedItem());
            if (!edit.cat.filename.equals(""))
            {
              edit.setTitle("Category Theory Database Tools [" + edit.cat.filename + "]");
              edit.validate();
            }
            else
            {
              edit.setTitle("Category Theory Database Tools [ CTDT 1999 ]");
              edit.validate();
            }
            edit.displayCategory(edit.cat);
            if (edit.cat.gml.equals(""))
              edit.GraphCategory(edit.graph_, edit.graphCanvas_, edit.cat);
            else
            {
              boolean display = edit.displayCategory(edit.cat.gml);
            }
          } */
          if (test == false)
          {
            new MessageDialog(this, "Error", "Unable to remove category", true);
          }
        }
        else
        {
          new MessageDialog(this, "Error", "Invalid category name", true);
        }
        funcRemoveList.clear();
        hide();
        dispose();
      }
      else
      {
        new MessageDialog(this, "Error", "No category file selected", true);
      }
  }
}
